%define name hwsetup-booyo
%define version 1.0
%define release 14

Name:		%{name}
Summary:	Automatic Hardware Setup
Version:	%{version}
Release:	%{release}
Copyright:	GPL
Group:		System/Tools
Source:		%{name}-%{version}.tar.bz2
Buildroot:	%{_tmppath}/%{name}-%{version}

BuildRequires:	kudzu-devel
BuildArchitectures: i586


%description
Automatic hardware setup using the kudzu library.
hwsetup-booyo is a non-interactive hardware setup tool that tries to read your
hardware setup from /etc/sysconfig/hwconf file and autoloads all necessary 
modules, plus generating the symlinks for mouse and cdrom/scanner in /dev.


##
## Setup Section
##

%prep
%setup -q


##
## Build Section
##

%build
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
mkdir -p $RPM_BUILD_ROOT

make


##
## Install Section
##

%install
strip hwsetup-booyo
mkdir -p %{buildroot}/sbin
install -m 755 hwsetup-booyo %{buildroot}/sbin


##
## Clean Section
##

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}-%{version}


##
## Files Section
##

%files
%defattr (-,root,root)
#%doc CHANGES README TODO VERSION
/sbin/hwsetup-booyo


##
## change log
##

%changelog
