/* Copyright 2004 Red Hat, Inc.
 *
 * This software may be freely redistributed under the terms of the GNU
 * public license.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * Modified by Myoung Tcheun to make /etc/sysconfig/hwconf
 */

#include <ctype.h>
#include <ftw.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#include <sys/utsname.h>

#include <kudzu/kudzu.h>


/* HACK. This is so not thread-safe. */
static char mod_name[100], cmod_name[100]; 

static int isModule(const char *filename, const struct stat *sb, int flag) {
	char *fname = basename(filename);
	if ((!strcmp(fname,mod_name) || !strcmp(fname,cmod_name))) {
		return 1;
	}
	return 0;
}


int isAvailable(char *modulename)
{
	struct utsname utsbuf;
	char path[512];
	
	uname(&utsbuf);
	snprintf(mod_name,100,"%s.ko",modulename);
	snprintf(cmod_name,100,"%s.ko.gz",modulename);
	snprintf(path,512,"/lib/modules/%s/kernel",utsbuf.release);
	/* Do not set the third argument of this function to < 6. Blarg. */
	if (ftw(path,isModule,15) == 1) {
		return 1;
	}
	return 0;
}


int main(int argc, char **argv) 
{
	int x;
	enum deviceBus probeBus = BUS_UNSPEC;
	struct device **devs;

	initializeBusDeviceList(probeBus);

	devs = readDevices("/etc/sysconfig/hwconf");
	if (!devs)
		return 0;
	for (x = 0; devs[x]; x++) {
		if (devs[x]->driver && isAvailable(devs[x]->driver)) {
			int i;
			
			for (i = 0; classes[i].classType; i++)
				if (devs[x]->type == classes[i].classType) {
					break;
				}
			printf("%s %s\n",classes[i].string,devs[x]->driver);
		}
	}
	return 0;
}
